/*
  Blink
  Turns on an LED on for one second, then off for one second, repeatedly.
 
  This example code is in the public domain.
 */
 
// Pin 13 has an LED connected on most Arduino boards.
// Pin 11 has the LED on Teensy 2.0
// Pin 6  has the LED on Teensy++ 2.0
// Pin 13 has the LED on Teensy 3.0
// give it a name:
// Needs to have PWM. Check analogWrite documentation
int led = 11; 


/*
int frequency = 36*2; // 36 spokes rotating twice per second
int delayUS = 1000000/frequency;
*/



////////////////////////////////////
// Array of brightness levels (0-255) for a slice in time
//const byte pattern[] = {0, 0, 0, 0, 0, 0, 30, 30, 0, 100, 0, 30, 30, 0, 0, 0, 0, 0, 10};
const byte pattern[] = {
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,};
const unsigned long patternTotalTimeUs = 1000;
const unsigned int patternDutyCyclePeriodUs = 25;
///////////////////////////////////



// Pre-allocate an array of on and off times
// Although they are still in SRAM. Could use PROGMEM instead
// to store in flash
const unsigned int n = sizeof(pattern)/sizeof(pattern[0]);
const unsigned long patternSliceTimeUs = 100;//patternTotalTimeUs / n;
unsigned int patternOnUs[n];
unsigned int patternOffUs[n];

int i = 0;
// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pin as an output.
  pinMode(led, OUTPUT); 
  Serial.begin(115200);

  for (i = 0; i < n; i++) {
    // Only one unsigned long (patternTotalTimeUs) will cast the whole equation to unsigned long
    // then cast the result back to unsigned int
    Serial.print(pattern[i]);
    Serial.print(",");
    Serial.print(n);
    Serial.print(",");
    Serial.print(((unsigned long)pattern[i] * n));
    Serial.print(",");
    patternOnUs[i] =  (unsigned int) (((unsigned long)pattern[i] * n) / patternTotalTimeUs);
    patternOffUs[i] = (unsigned int) (((unsigned long)(100-pattern[i]) * n) / patternTotalTimeUs);
    Serial.print(patternOnUs[i]);
    Serial.print(",");
    Serial.println(patternOffUs[i]);
  }
  setPwmFrequency(led, 1);
}

// Once every 7ms, or 7000 us

// the loop routine runs over and over again forever:
int delayUS = 100;
int delayUSstep = 5;
int illuminationUS = 9700;

int reps = 30;
int count = 0;
// Dim period
int dimUS = 1000 * 1000/60;
int dimCounterUS = 0;
int dutyCyclePercent = 1;
int dutyCyclePeriodUS = 100;
int dutyCycleOnPeriodUS = dutyCyclePeriodUS * dutyCyclePercent / 100;
int dutyCycleOffPeriodUS = dutyCyclePeriodUS * (100 - dutyCyclePercent) / 100;

unsigned int dutyCycleTotal = 0;
void loop() {
  /*
  Serial.println(dutyCycleOnPeriodUS);
  Serial.println(dutyCycleOffPeriodUS);
  */



  // Setting digitalWrite has some leaks! I wonder what true PWM looks like...

  
  for (i = 0; i < n; i++) {
    dutyCycleTotal = 0;
    analogWrite(led, pattern[i]);
    delayMicroseconds(patternSliceTimeUs);
    /*
    Serial.print(pattern[i] * patternDutyCyclePeriodUs / 100);
    Serial.print(",");
    Serial.println((100-pattern[i]) * patternDutyCyclePeriodUs / 100);
    while (dutyCycleTotal < patternSliceTimeUs) {
      if (pattern[i] * patternDutyCyclePeriodUs / 100 > 0) {
        digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
        delayMicroseconds(pattern[i] * patternDutyCyclePeriodUs / 100);              // wait for a bit
      }
      if ((100-pattern[i]) * patternDutyCyclePeriodUs / 100 > 0) {
        digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
        delayMicroseconds((100-pattern[i]) * patternDutyCyclePeriodUs / 100);              // wait for a bit
      }
      dutyCycleTotal += patternDutyCyclePeriodUs;
    }
    */
  }
  /*
  digitalWrite(led, HIGH);
  delayMicroseconds(150);
  digitalWrite(led, LOW);
    
  dimCounterUS = 0;

  //delay(10);

  while (dimCounterUS < 10 * 1000) {
    digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
    delayMicroseconds(0);        // wait for a bit
    digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
    delayMicroseconds(50);
    dimCounterUS += 50;
  }
  */

  /*
  while (dimCounterUS < dimUS) {
    digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
    delayMicroseconds(dutyCycleOnPeriodUS);        // wait for a bit
    digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
    delayMicroseconds(dutyCycleOffPeriodUS);
    dimCounterUS += dutyCyclePeriodUS;
  }
  */
/*
  count += 1;
  if (count == reps) {
    count = 0;
    delayUS += delayUSstep;
    Serial.println(delayUS);
  }
  */
  
}



/**
 * Divides a given PWM pin frequency by a divisor.
 * 
 * The resulting frequency is equal to the base frequency divided by
 * the given divisor:
 *   - Base frequencies:
 *      o The base frequency for pins 3, 9, 10, and 11 is 31250 Hz.
 *      o The base frequency for pins 5 and 6 is 62500 Hz.
 *   - Divisors:
 *      o The divisors available on pins 5, 6, 9 and 10 are: 1, 8, 64,
 *        256, and 1024.
 *      o The divisors available on pins 3 and 11 are: 1, 8, 32, 64,
 *        128, 256, and 1024.
 * 
 * PWM frequencies are tied together in pairs of pins. If one in a
 * pair is changed, the other is also changed to match:
 *   - Pins 5 and 6 are paired on timer0
 *   - Pins 9 and 10 are paired on timer1
 *   - Pins 3 and 11 are paired on timer2
 * 
 * Note that this function will have side effects on anything else
 * that uses timers:
 *   - Changes on pins 3, 5, 6, or 11 may cause the delay() and
 *     millis() functions to stop working. Other timing-related
 *     functions may also be affected.
 *   - Changes on pins 9 or 10 will cause the Servo library to function
 *     incorrectly.
 * 
 * Thanks to macegr of the Arduino forums for his documentation of the
 * PWM frequency divisors. His post can be viewed at:
 *   http://forum.arduino.cc/index.php?topic=16612#msg121031
 */
void setPwmFrequency(int pin, int divisor) {
  byte mode;
  if(pin == 5 || pin == 6 || pin == 9 || pin == 10) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 64: mode = 0x03; break;
      case 256: mode = 0x04; break;
      case 1024: mode = 0x05; break;
      default: return;
    }
    if(pin == 5 || pin == 6) {
      TCCR0B = TCCR0B & 0b11111000 | mode;
    } else {
      TCCR1B = TCCR1B & 0b11111000 | mode;
    }
  } else if(pin == 3 || pin == 11) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 32: mode = 0x03; break;
      case 64: mode = 0x04; break;
      case 128: mode = 0x05; break;
      case 256: mode = 0x06; break;
      case 1024: mode = 0x07; break;
      default: return;
    }
    TCCR2B = TCCR2B & 0b11111000 | mode;
  }
}
